"""
Sprout
Copyright(C), 2005, Enfold Systems, LLC - ALL RIGHTS RESERVED

This software is licensed under the Terms and Conditions contained
within the License.txt file that accompanied this software.  Any inquiries
concerning the scope or enforceability of the license should be addressed to:

Enfold Systems, LLC
4617 Montrose Blvd., Suite C215
Houston, Texas 77006 USA
p. +1 713.942.2377 | f. +1 832.201.8856
www.enfoldsystems.com
info@enfoldsystems.com

$Id: base.py 2262 2006-01-20 20:25:13Z sidnei $
"""
import sys
from cStringIO import StringIO
from pprint import pprint
from difflib import unified_diff

# Load fixture
from Testing import ZopeTestCase

ZopeTestCase.installProduct('SiteAccess')
ZopeTestCase.installProduct('ZCatalog')
ZopeTestCase.installProduct('PortalTransforms')
ZopeTestCase.installProduct('MimetypesRegistry')
ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('Sprout')

from Products.CMFPlone.tests import PloneTestCase

class BaseTest(PloneTestCase.PloneTestCase):

    def afterSetUp(self):
        PloneTestCase.PloneTestCase.afterSetUp(self)

    def assertStructEquals(self, got, expected):
        _got = StringIO()
        _expected = StringIO()
        pprint(got, _got)
        pprint(expected, _expected)
        _got = _got.getvalue().splitlines()
        _expected = _expected.getvalue().splitlines()
        diff = unified_diff(_expected, _got)
        self.failUnless(got == expected, '\n'.join(diff))
