"""
Sprout
Copyright(C), 2005, Enfold Systems, LLC - ALL RIGHTS RESERVED

This software is licensed under the Terms and Conditions contained
within the License.txt file that accompanied this software.  Any inquiries
concerning the scope or enforceability of the license should be addressed to:

Enfold Systems, LLC
4617 Montrose Blvd., Suite C215
Houston, Texas 77006 USA
p. +1 713.942.2377 | f. +1 832.201.8856
www.enfoldsystems.com
info@enfoldsystems.com

$Id: __init__.py 1456 2005-09-14 03:48:16Z leo $
"""
from zLOG import LOG, INFO

def log(msg):
    LOG('Sprout', INFO, msg)

PATTERN = '__Sprout_%s__'
def call(self, __name__, *args, **kw):
    return getattr(self, PATTERN % __name__)(*args, **kw)

WRAPPER = '__Sprout_is_wrapper_method__'
ORIG_NAME = '__Sprout_original_method_name__'
def isWrapperMethod(meth):
    return getattr(meth, WRAPPER, False)

def wrap_method(klass, name, method, pattern=PATTERN):
    old_method = getattr(klass, name)
    if isWrapperMethod(old_method):
        log('Wrapping already wrapped method at %s.%s' %
            (klass.__name__, name))
    else:
        log('Wrapping method at %s.%s' %
            (klass.__name__, name))
    new_name = pattern % name
    setattr(klass, new_name, old_method)
    setattr(method, ORIG_NAME, new_name)
    setattr(method, WRAPPER, True)
    setattr(klass, name, method)

def unwrap_method(klass, name):
    old_method = getattr(klass, name)
    if not isWrapperMethod(old_method):
        raise ValueError, ('Trying to unwrap non-wrapped '
                           'method at %s.%s' % (klass.__name__, name))
    orig_name = getattr(old_method, ORIG_NAME)
    new_method = getattr(klass, orig_name)
    delattr(klass, orig_name)
    setattr(klass, name, new_method)
