"""
Sprout
Copyright(C), 2005, Enfold Systems, LLC - ALL RIGHTS RESERVED

This software is licensed under the Terms and Conditions contained
within the License.txt file that accompanied this software.  Any inquiries
concerning the scope or enforceability of the license should be addressed to:

Enfold Systems, LLC
4617 Montrose Blvd., Suite C215
Houston, Texas 77006 USA
p. +1 713.942.2377 | f. +1 832.201.8856
www.enfoldsystems.com
info@enfoldsystems.com

$Id: test_doctests.py 2260 2006-01-20 18:57:04Z sidnei $
"""

import os, sys

if __name__ == '__main__':
    execfile(os.path.join(os.path.dirname(sys.argv[0]), 'framework.py'))

# Load fixture
from Testing import ZopeTestCase
from Testing.ZopeTestCase import FunctionalDocFileSuite
from cStringIO import StringIO

from Products.CMFCore.utils import getToolByName
from Products.Sprout.tests.base import BaseTest

class FunctionalTest(ZopeTestCase.Functional, BaseTest):

    def afterSetUp(self):
        BaseTest.afterSetUp(self)
        self.loginPortalOwner()

class DocTest(FunctionalTest):

    def afterSetUp(self):
        FunctionalTest.afterSetUp(self)
        self.qi = getToolByName(self.portal, 'portal_quickinstaller')
        self.qi.installProduct('Archetypes')
        self.qi.installProduct('Sprout')
        self.portal.clearCurrentSkin()
        self.portal.setupCurrentSkin()

def test_suite():
    import unittest
    suite = unittest.TestSuite()
    functional = (
        (DocTest, 'navigation.txt'),
        )
    for klass, docfile in functional:
        suite.addTest(
            FunctionalDocFileSuite(docfile,
                                   test_class=klass,
                                   package='Products.Sprout.tests'))

    return suite

if __name__ == '__main__':
    framework(descriptions=0, verbosity=1)
